# coding: utf-8

"""
    Stayforge API

    This is a basic API description.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.price import Price
from openapi_client.models.price_max import PriceMax
from openapi_client.models.price_min import PriceMin
from typing import Optional, Set
from typing_extensions import Self

class RoomTypeInput(BaseModel):
    """
    RoomTypeInput
    """ # noqa: E501
    name: StrictStr = Field(description="The Type of RoomType")
    description: Optional[StrictStr] = Field(default=None, description="Description of the room type.")
    price: Price
    price_policy: Optional[StrictStr] = Field(default=None, description="The price controller will modify the corresponding price field based on the price policy ID.")
    price_max: Optional[PriceMax] = None
    price_min: PriceMin
    __properties: ClassVar[List[str]] = ["name", "description", "price", "price_policy", "price_max", "price_min"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RoomTypeInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of price
        if self.price:
            _dict['price'] = self.price.to_dict()
        # override the default output from pydantic by calling `to_dict()` of price_max
        if self.price_max:
            _dict['price_max'] = self.price_max.to_dict()
        # override the default output from pydantic by calling `to_dict()` of price_min
        if self.price_min:
            _dict['price_min'] = self.price_min.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RoomTypeInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "price": Price.from_dict(obj["price"]) if obj.get("price") is not None else None,
            "price_policy": obj.get("price_policy"),
            "price_max": PriceMax.from_dict(obj["price_max"]) if obj.get("price_max") is not None else None,
            "price_min": PriceMin.from_dict(obj["price_min"]) if obj.get("price_min") is not None else None
        })
        return _obj


